	program wrfbucket03

!	Program will read in the total accumulated precipitation from
!	a series of WRFPRS files, and compute simple differences to
!	get precip buckets with a duration equal to the interval between
!	output times (3 h for current purposes)

	include "parmeta"

	real pdiff(im,jm)
	character(len=3), dimension(81):: hrs

	data hrs/'000','003','006','009','012','015','018','021','024', &
                       '027','030','033','036','039','042','045','048', &
      	               '051','054','057','060','063','066','069','072', &
                       '075','078','081','084','087','090','093','096', &
                       '099','102','105','108','111','114','117','120', &
	               '123','126','129','132','135','138','141','144', &
                       '147','150','153','156','159','162','155','168', &
      	               '171','174','177','180','183','186','189','192', &
                       '195','198','201','204','207','210','213','216', &
                       '219','222','225','228','231','234','237','240'/

	character(len=255):: file1,file2,file3,file4,file5,testout
	character(len=255):: indirname,outdirname
	character(len=255):: filename
        integer:: hour
        integer:: inn,outn

	read(5,FMT='(A)') indirname
	read(5,FMT='(A)') filename
	read(5,FMT='(A)') outdirname
	read(5,FMT='(I)') hour

	inn=index(indirname,' ')-1
	outn=index(outdirname,' ')-1
	m=index(filename,' ')-1


!	do I=2,17
        I=hour/3+1

	file1=   indirname(1:inn)//'/'//filename(1:m)// &
                HRS(I-1)//'.tm00'
	file2=   indirname(1:inn)//'/'//filename(1:m)// &
                HRS(I)//'.tm00'
	testout= outdirname(1:outn)//'/WRFPCP03_'//HRS(I)//'.tm00'
        print*,'hour',hour
        print*,'file1',file1
        print*,'file2',file2
	print*,'output file',testout

	mm=index(file1,' ')-1
	nn=index(file2,' ')-1
	mmm=index(testout,' ')-1
	call calc_pdiff(file1(1:mm),file2(1:nn),TESTOUT(1:mmm),pdiff)

!	enddo

	END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	SUBROUTINE CALC_PDIFF(FNAME1,FNAME2,TESTOUT,DPRECIP)
	include "parmeta"
	character(*):: FNAME1,FNAME2,testout
	integer:: JPDS(200),JGDS(200)
	integer:: KPDS1(200),KGDS(200),KPDS2(200),KPDS(200),KGDS2(200)
	logical:: BITMAP(IM*JM),FIRST
	real:: p_later(IM*JM),p_earlier(IM*JM),dprecip(im*jm)
	real:: c_later(IM*JM),c_earlier(IM*JM),dconv(im*jm)
	real:: nc_later(IM*JM),nc_earlier(IM*JM),dnonconv(im*jm)
	

	call baopen(11,fname1,ierr1)
	call baopen(12,fname2,ierr2)
	call baopen(13,testout,ierr3)

!c	write(6,*) 'baopened ', fname1,fname2,testout

	if ( (ierr1+ierr2+ierr3) .ne. 0) then
                print*,'ierr ',ierr1, ierr2, ierr3
		write(6,*) 'bad baopen!!! ', ierr1
		write(6,*) 'bad baopen!!! ', ierr2
		write(6,*) 'bad baopen!!! ', ierr3
		STOP
	endif
	
	jpds=-1
	jgds=-1

	jpds(5)=61
	jpds(6)=1
	jpds(7)=0

	p_earlier=0.
	nc_earlier=0.
	c_earlier=0.

        call getgb(11,0,im*jm,0,JPDS,JGDS,nwords,KNUM,KPDS1,KGDS, &
          BITMAP,p_earlier,IRET1)
	if (IRET1 .ne. 0) then
	write(6,*) 'bad getgb1 earlier ', IRET1
	STOP
	endif

!         jpds(5)=62
!        call getgb(11,0,im*jm,0,JPDS,JGDS,nwords,KNUM,KPDS1,KGDS,
!     &     BITMAP,nc_earlier,IRET1)
!	if (IRET1 .ne. 0) then
!	write(6,*) 'bad getgb1 non-conv earlier ', IRET1
!	STOP
!	endif

!wrf-rr has convective pcp
	jpds(5)=63
        call getgb(11,0,im*jm,0,JPDS,JGDS,nwords,KNUM,KPDS1,KGDS, &
         BITMAP,c_earlier,IRET1)
	if (IRET1 .ne. 0) then
	write(6,*) 'bad getgb1 conv earlier ', IRET1
	STOP
	endif

	nc_earlier=p_earlier-c_earlier

	jpds=-1
	jgds=-1

	jpds(5)=61
	jpds(6)=1
	jpds(7)=0

        call getgb(12,0,im*jm,0,JPDS,JGDS,nwords,KNUM,KPDS2,KGDS2,&
          BITMAP,p_later,IRET1)
	if (IRET1 .ne. 0) then
	 write(6,*) 'bad getgb later ', IRET1
	STOP
	endif

!	jpds(5)=62
!        call getgb(12,0,im*jm,0,JPDS,JGDS,nwords,KNUM,KPDS2,KGDS2, &
!     &     BITMAP,nc_later,IRET1)
!	if (IRET1 .ne. 0) then
!	 write(6,*) 'bad getgb non-conv later ', IRET1
!	STOP
!	endif

!lrb wrf-rr has convective precipitation
	jpds(5)=63
        call getgb(12,0,im*jm,0,JPDS,JGDS,nwords,KNUM,KPDS2,KGDS2,&
          BITMAP,c_later,IRET1)
	if (IRET1 .ne. 0) then
	 write(6,*) 'bad getgb conv later ', IRET1
	STOP
	endif

	nc_later=p_later-c_later


	do NPT=1,IM*JM
           dprecip(NPT)=p_later(NPT)-p_earlier(NPT)
	   dnonconv(NPT)=nc_later(NPT)-nc_earlier(NPT)
	   dconv(NPT)=c_later(NPT)-c_earlier(NPT)

!lrb         Zero out negative values if they are not too large in magnitude
!lrb         We should not have large negative values because we are 
!lrb         outputting precip from the Post with high precision (SCAL=5)
!lrb         If we do have large negative values, let them be noticed

             if(dnonconv(npt).lt.0.0)then
                if(dnonconv(npt).gt.-0.01)then
                   dnonconv(npt)=0.00
                else
                   print*,'Large neg value dnonconv ',npt,dnonconv(npt)
                endif
             endif
                
             if(dprecip(npt).lt.0.0)then
                if(dprecip(npt).gt.-0.01)then
                   dprecip(npt)=0.00
                else
                   print*,'Large neg value dprecip ',npt,dprecip(npt)
                endif
             endif

             if(dconv(npt).lt.0.0)then
                if(dconv(npt).gt.-0.01)then
                   dconv(npt)=0.00
                else
                   print*,'Large neg value dconv ',npt,dconv(npt)
                endif
             endif

        enddo


	KPDS2(14)=KPDS1(15)
	KPDS2(16)=4

	do N=1,23
!	write(6,*) 'N,KPDS(N): ', N,KPDS2(N)
	enddo

!! 	force decimal scaling
	KPDS2(22)=3
!! 	force decimal scaling

!	write(6,*) 'nwords, im*jm: ', nwords, im*jm

	KPDS2(5)=61
	call putgb(13,NWORDS,KPDS2,KGDS2,BITMAP,DPRECIP,IRET)
	KPDS2(5)=62
	call putgb(13,NWORDS,KPDS2,KGDS2,BITMAP,DNONCONV,IRET)
	KPDS2(5)=63
	call putgb(13,NWORDS,KPDS2,KGDS2,BITMAP,DCONV,IRET)

!lrb	write(6,*) 'extremes of precip, non-conv, and conv: ', &
!lrb    		maxval(dprecip),maxval(dnonconv),maxval(dconv)


	write(6,*) 'extremes of precip ', maxval(dprecip)


!lrb  633	format(25(f4.1,1x))

	end subroutine calc_pdiff
