      SUBROUTINE CALWXT_EXPLICIT(LMH,THS,PMID,PREC,SR,F_RIMEF,IWX)
C 
C     FILE: CALWXT.f
C     WRITTEN: 24 AUGUST 2005, G MANIKIN and B FERRIER 
C
C     ROUTINE TO COMPUTE PRECIPITATION TYPE USING EXPLICIT FIELDS
C       FROM THE MODEL MICROPHYSICS

!      INCLUDE "parmeta"
      INCLUDE "params"
      INCLUDE "CTLBLK.comm"
C
      PARAMETER (PTHRESH=0.000004)
C
C  LIST OF VARIABLES NEEDED
C    PARAMETERS:
C
C    INPUT:
      DIMENSION F_RimeF(IM,jsta_2l:jend_2u,LM), THS(IM,jsta_2l:jend_2u)
      REAL LMH(IM,jsta_2l:jend_2u),PREC(IM,jsta_2l:jend_2u)
      REAL SR(IM,jsta_2l:jend_2u)
      REAL PMID(IM,jsta_2l:jend_2u,LM)
      DIMENSION IWX(IM,JM)
C     
C
C     ALLOCATE LOCAL STORAGE
C
!$omp  parallel do
      DO J=JSTA,JEND
      DO I=1,IM
        IWX(I,J) = 0
      ENDDO
      ENDDO

CGSM  THE RSM IS CURRENTLY INCOMPATIBLE WITH THIS ROUTINE
CGSM   ACCORDING TO B FERRIER, THERE MAY BE A WAY TO WRITE
CGSM   A VERSION OF THIS ALGORITHM TO WORK WITH THE RSM
CGSM   MICROPHYSICS, BUT IT DOESN'T EXIST AT THIS TIME
 
      IF (MODELNAME .EQ. 'RSM') GOTO 810 
C
!$omp  parallel do
!$omp& private(lmhk,psfc,tskin)
      DO 800 J=JSTA,JEND
      DO 800 I=1,IM
      LMHK=LMH(I,J)
C
C   SKIP THIS POINT IF NO PRECIP THIS TIME STEP 
C
      IF (PREC(I,J).LE.PTHRESH) GOTO 800
C
C  A SNOW RATIO LESS THAN 0.5 ELIMINATES SNOW AND SLEET
C   USE THE SKIN TEMPERATURE TO DISTINGUISH RAIN FROM FREEZING RAIN
C   NOTE THAT 2-M TEMPERATURE MAY BE A BETTER CHOICE IF THE MODEL
C   HAS A COLD BIAS FOR SKIN TEMPERATURE
C 
      IF (SR(I,J).LT.0.5) THEN
C        SURFACE (SKIN) POTENTIAL TEMPERATURE AND TEMPERATURE.
         PSFC=PMID(I,J,LMHK)
         TSKIN=THS(I,J)*(PSFC/P1000)**CAPA 

       IF (TSKIN.LT.273.15) THEN
C          FREEZING RAIN = 4
           IWX(I,J)=IWX(I,J)+4
       ELSE
C          RAIN = 8
           IWX(I,J)=IWX(I,J)+8
       ENDIF
       ELSE
C  
C  DISTINGUISH SNOW FROM SLEET WITH THE RIME FACTOR
C 
        IF(F_RimeF(I,J,LMHK).GE.10) THEN
C          SLEET = 2
           IWX(I,J)=IWX(I,J)+2
        ELSE
           SNOW = 1
           IWX(I,J)=IWX(I,J)+1 
       ENDIF
      ENDIF
 800  CONTINUE
 810  RETURN 
      END
